<script>
import Vue from 'vue';

export default Vue.extend({
  name: 'Section',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    hasGradient: {
      type: Boolean,
      required: false,
      default: false,
    },
    hasDarkBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
    offsetImage: {
      type: Number,
      required: false,
      default: 0,
    },
    reverse: {
      type: Boolean,
      required: false,
      default: false,
    },
    icon: {
      type: String,
      required: false,
      default: '',
    },
    cropped: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  computed: {
    getPageName() {
      return this.$parent.content.slug;
    },
    cssImageProps() {
      return {
        '--margin-top': `${this.offsetImage}px`,
      };
    },
  },
});
</script>

<template>
  <div
    class="slp-py-96"
    :class="
      hasDarkBackground
        ? 'kubecon-section__dark'
        : hasGradient
        ? 'kubecon-section'
        : ''
    "
  >
    <SlpContainer>
      <SlpRow
        :class="[
          data.centered ? 'centered' : '',
          reverse ? 'section--reverse' : '',
        ]"
        class="section__row"
      >
        <SlpColumn
          class="section__col"
          :cols="6"
          :class="hasDarkBackground ? 'kubecon-section__dark-text' : ''"
        >
          <img
            v-if="icon"
            :src="`/nuxt-images/icons/events/${icon}.svg`"
            alt=""
            class="slp-mb-8"
          />
          <SlpTypography
            v-if="data.header"
            :variant="hasGradient ? 'heading2-bold' : 'heading4-bold'"
            tag="h3"
            class="slp-pb-24"
          >
            {{ data.header }}
          </SlpTypography>
          <div
            v-if="data.text"
            class="information"
            v-html="$md.render(data.text)"
          ></div>
          <SlpButton
            v-if="data.cta?.text"
            :href="data.cta.externalUrl"
            :data-ga-name="data.cta.dataGaName"
            :data-ga-location="data.cta.dataGaLocation"
            class="slp-mb-48"
            :variant="hasDarkBackground ? 'secondary' : 'primary'"
            >{{ data.cta.text }}</SlpButton
          >
        </SlpColumn>
        <SlpColumn
          class="section__col"
          :cols="6"
          :style="data.alignTop ? 'align-self: top' : 'align-self: center'"
        >
          <div
            v-if="data.assets.length"
            class="kubecon-section__img-wrapper"
            :class="[
              offsetImage ? 'kubecon-section__img--offset' : '',
              !cropped ? 'not-cropped' : '',
            ]"
            :style="cssImageProps"
          >
            <img
              v-for="image in data.assets"
              :key="image.alt"
              class="kubecon-section__img"
              :src="image.src"
              :alt="image.alt"
            />
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.kubecon-section {
  background: linear-gradient(
    165.41deg,
    #fadcd7 0%,
    #f8f5ff 23.65%,
    #ffffff 54.66%,
    #f6f3fe 80.95%,
    #ffd4d8 100.92%
  );

  &__dark {
    background: $color-surface-700;

    &-text {
      color: $color-text-50;
    }
  }

  &__img-wrapper {
    border-radius: 4px 4px 90px 4px;
    overflow: hidden;
    object-fit: cover;
    position: relative;
    display: block;
    line-height: 0;

    &.not-cropped {
      border-radius: 0;
    }
  }
  &__img {
    max-width: 100%;
    height: 100%;
    width: 100%;

    @media screen and (min-width: $breakpoint-md) {
      &--offset {
        position: relative;
        margin-top: var(--margin-top);
      }
    }
  }
}

.accent-colour {
  color: $color-accent-300;
}

.centered {
  align-items: flex-start;
}

.information {
  display: block;
  font-size: 20px;
  line-height: 24px;
  &:deep {
    p {
      display: block;
      margin-bottom: $spacing-16;
    }
    em {
      font-size: 14px;
      font-weight: 400;
      line-height: 20px;
      font-style: normal;
    }
    strong {
      font-weight: 600;
    }
  }
}
.section {
  &--reverse {
    @media screen and (min-width: $breakpoint-md) {
      flex-direction: row-reverse;
    }
  }
  &__row {
    margin-left: -24px;
  }
  &__col {
    padding-left: 24px;
  }
}
</style>
